(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["highchartsFunctions"] = factory();
	else
		root["highchartsFunctions"] = factory();
})(typeof self !== 'undefined' ? self : this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "TE4t");
/******/ })
/************************************************************************/
/******/ ({

/***/ "TE4t":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (immutable) */ __webpack_exports__["getLineChart"] = getLineChart;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_moment__ = __webpack_require__("Zz1P");
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_moment___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_moment__);


function getLineChart(config, result) {
  var kpchart = void 0;

  if (result && result.length > 0 && config.storedSelectedAssets && config.storedSelectedAssets.length > 0) {
    var seriesData = [];
    var selectedAssets = [];
    config.storedSelectedAssets.forEach(function (asset) {
      selectedAssets.push({
        id: asset
      });

      var resultSpecificExtents = [];
      result.forEach(function (ext) {
        var containsExtent = selectedAssets.filter(function (selAsset) {
          return selAsset.id === ext.extent;
        });
        if (containsExtent.length > 0 || config.storedSelectedAsset === ext.extent) {
          resultSpecificExtents.push(ext);
        }
      });

      // loop through and find the min an the max of all extetns if the kp_begin and kp_end is not set use this
      var min = 100000000000000;
      var max = -100000000000000;
      resultSpecificExtents.forEach(function (act) {
        if (act.kp_begin !== null && act.kp_begin < min) {
          min = act.kp_begin;
        }
        if (act.kp_begin !== null && act.kp_end > max) {
          max = act.kp_end;
        }
      });

      resultSpecificExtents.forEach(function (act2) {
        if ((act2.kp_begin === null || act2.kp_begin === undefined) && (act2.kp_end === null || act2.kp_end === undefined) && (act2.kp_postion === null || act2.kp_postion === undefined)) {
          act2.kp_begin = config.chartBegin;
          act2.kp_end = config.chartEnd;
        }
        if ((act2.kp_begin === null || act2.kp_begin === undefined) && (act2.kp_position !== null || act2.kp_position !== undefined)) {
          act2.kp_begin = act2.kp_position;
        }
        if ((act2.kp_end === null || act2.kp_end === undefined) && (act2.kp_position !== null || act2.kp_position !== undefined)) {
          act2.kp_end = act2.kp_begin;
          act2.type = 'Point';
        }
      });

      var newResults = [];
      if (resultSpecificExtents.length > 0) {
        config.timeCounter = 0;
        var timeUnit = config.timeUnit;
        var yAxisText = void 0;
        var endDate = new Date(config.timeVariableTo, 12, 31);

        for (var i = 0; i < resultSpecificExtents.length; i++) {
          var activity = resultSpecificExtents[i];
          if (activity.extent === asset) {
            var startDate = Date.parse(activity.start_date);
            var theDate = new Date(startDate);
            if (timeUnit === 'years') {
              yAxisText = __WEBPACK_IMPORTED_MODULE_0_moment___default()(theDate).format('YYYY');
            } else if (timeUnit === 'months') {
              yAxisText = __WEBPACK_IMPORTED_MODULE_0_moment___default()(theDate).format('MMM-YYYY');
            } else if (timeUnit === 'weeks') {
              yAxisText = __WEBPACK_IMPORTED_MODULE_0_moment___default()(theDate).format('WW-YYYY');
            }

            activity.start = startDate;
            activity.yAxis = yAxisText;

            newResults.push(activity);

            if (activity.isMasterPlanActivity) {
              // //recurring activities

              var intervalDate = new Date(activity.start_date);

              // Makes as many as needed maximum 100
              for (var k = 0; k < 100; k++) {
                if (!activity.last_occurance) {
                  intervalDate = findDate(intervalDate, activity.interval, activity.interval_unit);
                } else {
                  var lastOccurance = Date.parse(activity.last_occurance);
                  var compareDate = findDate(intervalDate, activity.interval, activity.interval_unit);
                  if (compareDate < lastOccurance) {
                    intervalDate = findDate(intervalDate, activity.interval, activity.interval_unit);
                  } else {
                    break;
                  }
                }

                if (intervalDate > endDate) {
                  break;
                }

                if (timeUnit === 'years') {
                  yAxisText = __WEBPACK_IMPORTED_MODULE_0_moment___default()(intervalDate).format('YYYY');
                } else if (timeUnit === 'months') {
                  yAxisText = __WEBPACK_IMPORTED_MODULE_0_moment___default()(intervalDate).format('MMM-YYYY');
                } else if (timeUnit === 'weeks') {
                  yAxisText = __WEBPACK_IMPORTED_MODULE_0_moment___default()(intervalDate).format('WW-YYYY');
                }

                var start = Date.parse(intervalDate);

                // Check if the extent has a name
                var extentName = config.extentDislayName ? config.extentDislayName : activity.extent;

                // Find the y-axis name
                var extentMethod = {
                  isMasterPlanActivity: activity.isMasterPlanActivity,
                  activity_name: activity.activity_name,
                  analysis_item: activity.analysis_item,
                  methodModelText: activity.methodModelText,
                  methodModel: activity.methodModel,
                  extent: extentName,
                  start: start,
                  yAxis: yAxisText,
                  first_occurance: activity.first_occurance,
                  interval: activity.interval,
                  interval_unit: activity.interval_unit,
                  last_occurance: activity.last_occurance,
                  kp_begin: activity.kp_begin,
                  kp_end: activity.kp_end,
                  kp_position: activity.kp_position,
                  activity_template_schedule: activity.activity_template_schedule,
                  activity: activity.activity,
                  template_id: activity.template_id,
                  type: activity.type
                };

                newResults.push(extentMethod);
              }
            }
          }
        }

        var category = [];
        var nDate = void 0;
        var timecounter = 0;
        var intervalYears = 1 + Number(config.timeVariableTo) - Number(config.timeVariableFrom);
        var intervalMonths = intervalYears * 12;
        var intervalWeeks = intervalYears * 52;

        // build up the yAxis information
        if (timeUnit === 'years') {
          for (var _i = 0; _i < intervalYears; _i++) {
            nDate = new Date(Number(config.timeVariableFrom) + timecounter, 0, 1);
            yAxisText = __WEBPACK_IMPORTED_MODULE_0_moment___default()(nDate).format('YYYY');
            category.push(yAxisText);
            timecounter++;
            config.timeVariable = intervalYears;
          }
        } else if (timeUnit === 'months') {
          for (var _i2 = 0; _i2 < intervalMonths; _i2++) {
            nDate = new Date(config.timeVariableFrom, 0 + timecounter, 1);
            yAxisText = __WEBPACK_IMPORTED_MODULE_0_moment___default()(nDate).format('MMM-YYYY');
            category.push(yAxisText);
            timecounter++;
            config.timeVariable = intervalMonths;
          }
          // yAxisText = date.getMonth().toString()
        } else if (timeUnit === 'weeks') {
          for (var _i3 = 0; _i3 < intervalWeeks; _i3++) {
            nDate = new Date(config.timeVariableFrom, 0, 1 + 7 * timecounter);
            yAxisText = __WEBPACK_IMPORTED_MODULE_0_moment___default()(nDate).format('WW-YYYY');
            category.push(yAxisText);
            timecounter++;
            config.timeVariable = intervalWeeks;
          }
        }

        // sort the methods based on startdate
        var sortedMethods = sortProperties(newResults, 'methodModel', false, false);

        // Build up the array
        var counter = 0;

        var _loop = function _loop(_k) {
          var method = sortedMethods[_k][1];
          var exist = seriesData.find(function (x) {
            return x.name === method.methodModel;
          });
          if (!exist) {
            seriesData.push({
              name: method.methodModel,
              minPointLength: 3,
              data: []
            });
          }

          var startString = new Date(method.start);

          // Find the index of the y-axis
          counter = -1;

          for (var j = 0; j < category.length; j++) {
            if (category[j] === method.yAxis) {
              counter = j;
              break;
            }
          }
          var navigationUrl = void 0;

          if (method.isMasterPlanActivity) {
            if (config.masterPlanIsEditable) {
              if (typeof config.editActivityTemplateRoute === 'function') {
                navigationUrl = config.editActivityTemplateRoute(method.template_id).href + '/3/' + method.activity_template_schedule;
              }
            } else {
              if (typeof config.viewActivityTemplateRoute === 'function') {
                navigationUrl = config.viewActivityTemplateRoute(method.template_id).href + '/3/' + method.activity_template_schedule;
              }
            }
          } else if (method.activity === 'Risk assessment') {
            navigationUrl = '#/RISKRESULTS/' + method.activityId;
          } else if (method.activity === 'HCA assessment') {
            navigationUrl = '#/HCA_RESULTS/' + method.activityId;
          } else if (method.activity === 'Class location assessement') {
            navigationUrl = '#/CLASS_LOCATION_RESULTS/' + method.activityId;
          } else if (method.activity === 'Analytical assessment') {
            navigationUrl = '#/RISKRESULTS/' + method.activityId;
          } else if (method.activity === 'General task') {
            navigationUrl = '#/GENERALTASK_SUMMERY' + method.activityId;
          } else if (method.activity === '') {
            navigationUrl = 'qualitativeriskassessment/qras/' + method.activityId;
          } else {
            navigationUrl = 'activity/integrity_activities/' + method.activity + '/' + method.activityId;
          }

          var start = startString ? __WEBPACK_IMPORTED_MODULE_0_moment___default()(startString).format('MMM DD, YYYY') : 'Undefined';
          var firstOccurance = method.first_occurance ? __WEBPACK_IMPORTED_MODULE_0_moment___default()(method.first_occurance).format('MMM DD, YYYY') : 'Undefined';
          var lastOccurance = method.last_occurance ? __WEBPACK_IMPORTED_MODULE_0_moment___default()(method.last_occurance).format('MMM DD, YYYY') : 'Undefined';
          var tooltipText = void 0;
          var kpText = method.type === 'Point' ? method.kp_begin : method.kp_begin + ' - ' + method.kp_end;
          if (method.isMasterPlanActivity) {
            tooltipText = '<tr><td>Activity name:</td><td>' + method.activity_name + '<tr><td>KP:</td><td>' + kpText + '</td></tr>' + '<tr><td>' + method.methodModelText + '</td><td>' + method.methodModel + '</td></tr>' + '<tr><td>Start:</td><td>' + start + '</td></tr>' + '<tr><td>First:</td><td>' + firstOccurance + '</td></tr>' + '<tr><td>Last:</td><td>' + lastOccurance + '</td></tr>' + '<tr><td>Recurrence:</td><td>' + method.interval + ' ' + method.interval_unit + '(s)</td></tr>' + '<tr><td>Extent:</td><td>' + method.extent + '</td></tr>' + '<tr><td>Note:</td><td>Click on bar to navigate ....</td></tr>';
          } else {
            tooltipText = '<tr><td>Activity name:</td><td>' + method.activity_name + '<tr><td>KP:</td><td>' + kpText + '</td></tr>' + '<tr><td>' + method.methodModelText + '</td><td>' + method.methodModel + '</td></tr>' + '<tr><td>Start:</td><td>' + start + '</td></tr>' + '<tr><td>Extent:</td><td>' + method.extent + '</td></tr>' + '<tr><td>Note:</td><td>Click on bar to navigate ....</td></tr>';
          }

          var exist2 = seriesData.find(function (x) {
            return x.name === method.methodModel;
          });
          if (exist2 && counter > -1 && method.kp_begin !== null && method.kp_end !== null) {
            var now = new Date();

            if (startString < now) {
              exist2 && exist2.data.push({
                x: method.kp_begin,
                x2: method.kp_end,
                y: counter,
                borderColor: 'grey',
                borderWidth: 2,
                properties: {
                  navigationUrl: navigationUrl,
                  tooltip: tooltipText
                }
              });
            } else {
              exist2 && exist2.data.push({
                x: method.kp_begin,
                x2: method.kp_end,
                y: counter,
                properties: {
                  navigationUrl: navigationUrl,
                  tooltip: tooltipText
                }
              });
            }
          }
        };

        for (var _k = 0; _k < sortedMethods.length; _k++) {
          _loop(_k);
        }

        var assetId = config.selectedAsset ? config.selectedAsset : '&lt; No asset selected &gt;';

        var chartTitle = config.chart && config.chart.title != null ? config.chart.title : {};
        if (chartTitle.text == null) {
          chartTitle.text = 'Scheduled activities for ' + assetId + ' (' + config.timeVariable + ' ' + config.timeUnit + ')';
        }

        var xAxisTitle = config.chart && config.chart.xAxis != null && config.chart.xAxis.title != null ? config.chart.xAxis.title : {};
        if (xAxisTitle.text == null) {
          xAxisTitle.text = 'KP range (' + config.unit + ')';
        }

        var yAxisTitle = config.chart && config.chart.yAxis != null && config.chart.yAxis.title != null ? config.chart.yAxis.title : {};
        if (yAxisTitle.text == null) {
          yAxisTitle.text = config.timeUnit.charAt(0).toUpperCase() + config.timeUnit.slice(1);
        }

        kpchart = {
          chart: {
            type: 'xrange',
            height: 100 + 75 * config.timeVariable,
            zoomType: 'x'
          },
          title: chartTitle,
          legend: {
            align: 'right',
            verticalAlign: 'top',
            layout: 'vertical',
            title: {
              text: 'Legend'
            },
            symbolRadius: 0,
            x: 0,
            y: 50
          },
          xAxis: {
            title: xAxisTitle,
            labels: config.chart && config.chart.xAxis != null && config.chart.xAxis.labels != null ? config.chart.xAxis.labels : {},
            min: config.chartBegin,
            max: config.chartEnd
          },
          yAxis: {
            title: yAxisTitle,
            labels: config.chart && config.chart.yAxis != null && config.chart.yAxis.labels != null ? config.chart.yAxis.labels : {},
            categories: category,
            reversed: false,
            min: 0,
            max: category.length - 1
          },
          tooltip: {
            useHTML: true,
            headerFormat: '<table>',
            pointFormat: '{point.properties.tooltip}',
            footerFormat: '</table>',
            followPointer: false
          },
          series: seriesData,
          plotOptions: {
            series: {
              colorByPoint: false,
              point: {
                events: {
                  click: function click() {
                    //  location.href = config.properties.navigationUrl
                  }
                }
              },
              turboThreshold: 0
            }
          }
        };
      } else {
        kpchart = {
          chart: {
            type: 'xrange',
            height: 100 + 75 * config.timeVariable,
            zoomType: 'xy'
          },
          title: {
            text: 'No data for ' + config.selectedAsset
          }
        };
      }
    });
  } else {
    kpchart = {
      chart: {
        type: 'xrange',
        height: 100 + 75 * config.timeVariable,
        zoomType: 'xy'
      },
      title: {
        text: 'No data available'
      }
    };
  }
  return kpchart;
}

function sortProperties(obj, sortedBy, isNumericSort, reverse) {
  sortedBy = sortedBy || 1; // by default first key
  isNumericSort = isNumericSort || false; // by default text sort
  reverse = reverse || false; // by default no reverse

  var reversed = reverse ? -1 : 1;

  var sortable = [];
  for (var key in obj) {
    if (obj.hasOwnProperty(key)) {
      sortable.push([key, obj[key]]);
    }
  }
  if (isNumericSort) {
    sortable.sort(function (a, b) {
      return reversed * (a[1][sortedBy] - b[1][sortedBy]);
    });
  } else {
    sortable.sort(function (a, b) {
      var x = a[1][sortedBy].toLowerCase();
      var y = b[1][sortedBy].toLowerCase();
      return x < y ? reversed * -1 : x > y ? reversed : 0;
    });
  }
  return sortable; // array in format [ [ key1, val1 ], [ key2, val2 ], ... ]
}

function findDate(date, interval, unit) {
  var years = date.getFullYear();
  var months = date.getMonth();
  var days = date.getDate();

  var newDate = void 0;
  if (unit === 'year') {
    newDate = new Date(years + interval, months, days);
  } else if (unit === 'month') {
    newDate = new Date(years, months + interval, days);
  } else if (unit === 'week') {
    newDate = new Date(years, months, days + interval * 7);
  } else if (unit === 'day') {
    newDate = new Date(years, months, days * interval);
  }

  return newDate;
}

/***/ }),

/***/ "Zz1P":
/***/ (function(module, exports) {

module.exports = require("moment");

/***/ })

/******/ });
});