(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["masterPlan"] = factory();
	else
		root["masterPlan"] = factory();
})(typeof self !== 'undefined' ? self : this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "hX/l");
/******/ })
/************************************************************************/
/******/ ({

/***/ "hX/l":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (immutable) */ __webpack_exports__["getFlattenedActivityTemplates"] = getFlattenedActivityTemplates;
function getFlattenedActivityTemplates(activityTemplates) {
  var results = [];

  activityTemplates.forEach(function (template) {
    if (template.schedule) {
      template.schedule.forEach(function (activity) {
        if (activity.extent == null) {
          return;
        }

        activity.extent.forEach(function (ext) {
          var methodModel = template.method ? template.method : template.model;

          if (template.activity_type === 'Threat assessment') {
            methodModel = 'Threat';
          } else if (template.activity_type === 'Qualitative risk assessment') {
            methodModel = 'Qualitative (' + template.analysis_item + ')';
          }

          var methodModelText = template.method ? 'Method' : 'Model';

          var extentMethod = {
            isMasterPlanActivity: true,
            activity_name: activity.name,
            analysis_item: template.analysis_item,
            methodModelText: methodModelText,
            methodModel: methodModel,
            extent: ext.external_id,
            first_occurance: activity.first_occurance,
            interval: activity.interval,
            interval_unit: activity.interval_unit,
            duration: activity.duration,
            duration_unit: activity.duration_unit,
            last_occurance: activity.last_occurance,
            kp_begin: ext.begin,
            kp_end: ext.end,
            kp_position: ext.position,
            activity_template_schedule: ext.activity_template_schedule,
            activity: template.activity_type,
            template_id: template.id,
            start_date: activity.first_occurance
          };

          results.push(extentMethod);
        });
      });
    }
  });

  return results;
}

/***/ })

/******/ });
});